ROUTE(8)

NAME
route - show / manipulate the IP routing table

SYNOPSIS
route [-vnee]

route
    [-v] add [-net|-host] Target [netmask Nm] [gw Gw] [metric N] [mss M] [window W] [irtt I] [reject] [mod] [dyn] [reinstate] [[dev] If]

route
    [-v] del [-net|-host] Target [gw Gw] [netmask Nm] [metric N] [[dev] If]

route
    [-V] [--version] [-h] [--help]

DESCRIPTION
Route manipulates the kernel's IP routing table. Its primary use is to set up static routes to specific hosts or networks via an interface after it has been configured with the ifconfig(8) program.

OPTIONS

-v  is a flag for verbose (not used).

-n  shows numerical addresses instead of trying to determine symbolic host names. This is useful if you are trying to determine why the route to your nameserver has vanished.

-e  use netstat(8)-format for displaying the routing table. -ee will generate a very long line with all parametres from the routing table.

-net
    the Target is the address of a network (found in /etc/networks by the getnetbyname(3) library function).

-host
    is the address of a host (found with gethostbyname(3) library function).

(none)
    displays the kernel routing table. The layout can be changed with -e and -ee

del deletes a route.

add adds a route.

Target
    The destination network or host. You can provide IP addresses in dotted decimal or host/network names.

netmask Nm
    modifier specifies the netmask of the route to be added. This only makes sense for a network route, and when the address Target actually makes sense with the specified netmask. If no netmask is given, route guesses it instead, so for most normal setups you won't need to specify a netmask.

gw Gw
    Any IP packets for the target network/host will be routed through the specified gateway. NOTE: The specified gateway must be reachable first. This usually means that you have to set up a static route to the gateway beforehand. If you specifie the adress of one of your local interfaces, it will be used to decide about the interface to which the packets should be routed to. This is a BSDism compatibility hack.

metric M
    Modifier sets the metric field in the roting table, used from daemons for dynamic routing.

mss M
    Modifier specifies the TCP Maximum Segment Size in Bytes (MSS) for TCP Connections over this route. This is normally used only for fine optimisation of routing setups. The default is 536.

window W
    Modifier specifies the TCP window size for TCP Connections over this route. This is typically only used on AX.25 networks and with drivers unable to handle back to back frames.

irtt I
    Modifier specifies the initial round trip time (irtt) for TCP Connections over this route. This is typically only used on AX.25 networks. The number is given in milliseconds (1-12000). If ommited the RFC 1122 default of 300ms is used.

reject
    Modifier installs a blocking route, which will force a route lookup to fail. This is for example used to mask out networks before using the default route. This is NOT for firewalling.

mod, dyn, reinstate
    Modifier installs a dynamic or modified route. Both Flags are generally only set by a routing daemon. This is only for diagnostic purpose.

dev If
    Modifier forces the route to be associated with the specified device, as the kernel will otherwise try to determine the device on its own (by checking already existing routes and device specifications, and where the route is added to). In most normal networks you won't need this. If dev If is the last option on the command line, the word dev may be omitted, as it's the default. Otherwise the order of the route modifiers (metric - netmask - gw - dev) doesn't matter.

EXAMPLES

route add -net 127.0.0.0
    adds the normal loopback entry, using netmask 255.0.0.0 (Class A net, determined from the destination address) and associated with the "lo" device (assuming this device was prviously set up correctly with ifconfig(8)).

route add -net 192.56.76.0 netmask 255.255.255.0 dev eth0
    adds a route to the network 192.56.76.x via "eth0". The Class C netmask modifier is not really necessary here because 192.* is a Class C IP address. The word "dev" can be omitted here.

route add default gw mango-gw
    adds a default route (which will be used if no other route matches). All packets using this route will be gatewayed through "mango-gw". The device which will actually be used for that route depends on how we can reach "mango-gw" - the static route to "mango-gw" will have to be set up before.

route add ipx4 sl0
    Adds the route to the "ipx4" host via the SLIP interface (assuming that "ipx4" is the SLIP host).

route add -net 192.57.66.0 netmask 255.255.255.0 gw ipx4
    This command adds the net "192.57.66.x" to be gatewayed through the former route to the SLIP interface.

route add -net 224.0.0.0 netmask 240.0.0.0 dev eth0
    This is an obscure one documented so people know how to do it. This sets all of the class D (multicast) IP routes to go via "eth0". This is the correct normal configuration line with a multicasting kernel.

route add -net 10.0.0.0 netmask 255.0.0.0 reject
    This installs a rejecting route for the private network "10.x.x.x."

OUTPUT
The Output of the kernel routing table is organized in the following columns

Destination
    The destination network or destination host.

Gateway
    The Gateway host or '*' if none set.

Genmask
    The netmask for the destination net '255.255.255.255' for a host destination and '0.0.0.0' for the default route.

Flags
    Possible flags are
    U (route is Up)
    H (target is a host)
    G (use gateway)
    R (reinstate route for dynamic routing)
    D (dynamically installed by daemon or redirect)
    M (modified from routing daemon or rederict)
    ! (reject route)

Metric
    The 'distance' to the targed (usually counted in hops). It is not used by recent kernels, only routing daemons may use it.

Ref Number of references to this route. Not used in the Linux kernel, always 0.

Use Count of lookups for the route. With recent kernels this numbers are very low, since the sockets have its own cache and dont need to lookup routes.

Iface
    Interface to which the IP Packages will be send.

MSS Default maximum segement size for TCP Connections over this route.

Window
    Default windowsize for TCP Connections over this route.

irtt
    Innitial RTT (Round Trip Time). The kernels use this to guess about the best TCP protocol parameters without waiting on (possible slow) answers.

FILES
/proc/net/route
/etc/networks
/etc/hosts
/etc/init.d/network

SEE ALSO
ifconfig(8), netstat(8), arp(8)

HISTORY
Route for Linux was originally written by Fred N. van Kempen, <waltje@uwalt.nl.mugnet.org> and then modified by Johannes Stille and Linus Torvalds for pl15. Alan Cox added the mss and window options for Linux 1.1.22. irtt support and merged with netstat from Bernd Eckenfels.

BUGS
none :)